<?php
/*
 * NagDash v.0.1 - A simple dashboard for the nagios network monitoring system.
 * Date: 2009-06-16
 * Author: John Kenyon <john@jlk.net.au>
 * Website: http://www.jlk.net.au/nagdash.php
 * License: This software is distributed under the GNU General Public License version 3 and comes with NO WARRANTY.
 *
 */
	// MySQL database connection details
	$DBusername = "nagdash";
	$DBpassword = "secret";
	$DBhostname = "localhost";
	$DBdataname = "nagdash";

	$DBconnection = mysql_connect($DBhostname, $DBusername, $DBpassword) or die("Unable to connect to connect to the database!");
	mysql_select_db($DBdataname);

	// HTML colour codes
        $font_green = "#52D017";
        $font_orange = "#E56717";
        $font_red = "#FF0000";
        $bg_grey = "#EDEDED";
?>

<html>
<h1>NagDash v.0.1</h1>
<p>Results last updated at: <?php echo date('h:i A'); ?></p>

<?php
	// The code has been split up into two sections: Summary and Detail.
	// I split this up so help people out, some users like to have a summary
	// on the main page of their website that links to the detailed section.
	// Feel free to modify the code to suit your needs - Enjoy!

	// This will provide a simple status summary message.
	$query_display_sum = "SELECT * FROM display";
	$result_display_sum = mysql_query($query_display_sum);

	$count_problems = 0;

	while($row_display_sum = mysql_fetch_array($result_display_sum, MYSQL_ASSOC))
	{
		$enabled_host = $row_display_sum['hostname'];

        	$query_services_sum = "SELECT * FROM services WHERE hostname='$enabled_host'";
        	$result_services_sum = mysql_query($query_services_sum);
        	$row_services_sum = mysql_num_rows($result_services_sum);

       		if($row_services_sum > 0)
		{
              		$count_problems = $count_problems + $row_services_sum;
       		}
	}

	if($count_problems > 0)
	{
        	$summary_msg = $count_problems . " Problems";
	} else {
		$summary_msg = "No Problems";
	}
	
	echo "<p>Status Summary: <b>" . $summary_msg . "</b></p>";
?>

<table width=100%>

<?php
	// This will provide a table of detailed information regarding hosts and services.
	$query_display = "SELECT * FROM display";
        $result_display = mysql_query($query_display);

	while($row_display = mysql_fetch_array($result_display, MYSQL_ASSOC))
	{
		$selected_host = $row_display['hostname'];

		$query_hosts  = "SELECT * FROM hosts WHERE hostname='$selected_host'";
		$result_hosts = mysql_query($query_hosts);

		if($row_hosts = mysql_fetch_array($result_hosts, MYSQL_ASSOC))
		{
			switch ($row_hosts['state'])
			{
				case "UP":
					$host_state="<font color=" . $font_green . ">ONLINE</font>";
					break;
				case "UNREACHABLE":
					$host_state="<font color=" . $font_orange . ">UNREACHABLE</font>";
					break;
				case "DOWN":
					switch ($row_hosts['statetype'])
					{
						case "SOFT":
							switch ($row_hosts['checkattempt'])
							{
								case "3":
									$host_state="<font color=" . $font_red . ">OFFLINE</font>";
									break;
								default:
									$host_state="<font color=" . $font_orange . ">UNREACHABLE</font>";
									break;
							}
						case "HARD":
							$host_state="<font color=" . $font_red . ">OFFLINE</font>";
							break;
					}
			}
			// Report the status of the host
			echo "<tr bgcolor=" . $bg_grey ."><td><b>" . $row_display['description'] . "</b></td><td align='center'><b>" . $host_state . "</b></td><tr>";
		} else { 
			echo "<tr bgcolor=" . $bg_grey ."><td><b>" . $row_display['description'] . "</b></td><td align='center'><b><font color=" . $font_green . ">ONLINE</font></b></td><tr>";
		}

		// Check the services of enabled hosts for any problems
		if($row_services_sum > 0)
		{
			while($row_services = mysql_fetch_array($result_services, MYSQL_ASSOC))
			{
				switch ($row_services['statetype'])
				{
					case "SOFT":
						switch ($row_services['checkattempt'])
						{
							case "3":
								$service_state="Status CRITICAL - Problem with " . $row_services['servicedesc'] . ", IT are working to resolve the issue.";
								$service_image="<img src='portal/images/nagdash-red.gif' align='left' alt='(CRITICAL) '>";
								break;
							default:
								$service_state="Status WARNING - Possible problem detected with " . $row_services['servicedesc'] . ".";
								$service_image="<img src='portal/images/nagdash-amber.gif' align='left' alt='(WARNING) '>";
								break;
						}
						break;
					case "HARD":
						$service_state="Status CRITICAL - Problem with " . $row_services['servicedesc'] . ", IT are working to resolve the issue.";
						$service_image="<img src='portal/images/nagdash-red.gif' align='left' alt='(CRITICAL) '>";
						break;
				}
				echo "<tr><td colspan=2>" . $service_image . $service_state . "</td><tr>";
			}
		} else {
			echo "<tr><td colspan=2><img src='portal/images/nagdash-green.gif' align='left' alt='(OK) '>Status OK - No system problems have been reported/detected.</td><tr>";
		}
	}
?>

</table>

<?php mysql_close($DBconnection); ?>
<p><i>Provided by: <a href="http://www.jlk.net.au/nagdash">NagDash</a></i></p>
</html>
